/**
 * Arrival section of Hamlet, the Well.
 * @param {HamletWellController} controller The Hamlet, Well controller.
 */
function HamletWellRope(controller, firstNext, secondNext, thirdNext) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = HamletWellArrivalChoice.ROPE;
    var reqController = ctrl.arrival;
    var subController = ctrl.down;
    var changeController = ctrl.rope;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    //var firstNext = new HamletWellSwim(ctrl);
    //var secondNext = new HamletWellClimb(ctrl);
    //var thirdNext = new HamletWellHelp(ctrl);

    var firstChoice = HamletWellFallChoice.SWIM;
    var secondChoice = HamletWellFallChoice.CLIMB;
    var thirdChoice = HamletWellFallChoice.HELP;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.drowned = true;
        global.kobold.history.shared.well.fell = true;
        var dick = ctrl.misc.dick();
        var toReturn = `[p]
                            After your depressing train of thoughts, you decide it's time to inspect the well more thoroughly.
                            There might be some coins at the bottom, and who knows what else you might find?
                            Some good old adventuring is exactly what you need to lift your spirits.
                        [/p]
                        [p]
                            You grab your ${global.kobold.inventory.createItemWithTooltip(new Rope())}, hoping to scale down the well.
                            There isn't anything around to tie it to, though.
                            The cable attached to the well's bucket is simply coiled off to the side,
                            but you don't think your own ${global.kobold.inventory.createItemWithTooltip(new Rope())} is long enough to reach the very bottom.
                            Still, you'd rather trust something Seki sold you than a random cord that's probably been out here for [b]years[/b].
                        [/p]
                        [p]
                            Pondering the logistics of this situation for a few seconds, you spot the solution lying on the ground.
                            A chunk of cobblestone has broken off the side of the well.
                            You figure it's perfect for tying your ${global.kobold.inventory.createItemWithTooltip(new Rope())} around!
                            It [i]seems[/i] and [i]feels[/i] heavy enough to support your weight, although if it actually [i]will[/i] remains to be seen.
                        [/p]
                        [p]
                            You attach one end of your cable to the piece of rock-wall, and toss the other end down the well.
                            You cast your gaze downwards, but it's too dark to see the bottom.
                            You're sure your eyes'll adapt to the darkness once you're down there.
                            And if they don't, you can climb back out, and it'll be like nothing happened! 
                        [/p]
                        [p]
                            Gathering your courage, you let out a determined grunt.
                            Knights are fearless, and if you want to be one, you can't shy away from adventure.
                            You need to plunge head-first into danger!
                            Well, maybe not head-first, but you still need to go down the well,
                            if just to prove to yourself that you [b]do[/b] have what it takes to stop being a thief one day.
                        [/p]
                        [p]
                            You hop ontop of the well's edge.
                            Facing away from the watering hole, you squat down.
                            With one hand, you tightly grip your ${global.kobold.inventory.createItemWithTooltip(new Rope())},
                            and with the other you take hold of the rim of the cobblestone wall.
                            You let out a deep, nerve-soothing sigh.
                            Here you go.
                        [/p]
                        [p]
                            You lower your body into the watering hole, distributing your weight evenly between the rope and the well itself.
                            To your pleasant surprise, everything seems to be holding!
                            You place your feet against the rock wall, and begin your descent.
                            The moment you let go of the edge of the well, however, something happens.
                        [/p]
                        [p]
                            Shifting your entire weight -- however light that may be -- onto the rope causes the rock you tied it to to [b]jerk[/b] forwards,
                            instantly dropping you down a couple of feet more.
                            [b]Oh no[/b]!
                            You yelp out in surprise, your heart beating a million times a minute, fearing for your very life.
                            You [b]knew[/b] you should have tested the chunk of cobblestone more thoroughly!
                            It [b]stopped moving[/b], for now, so you think it might be [i]trapped[/i] against the side of the well.
                            As long as nothing [i]breaks[/i], you should be fine.
                        [/p]
                        [p]
                            Adrenaline coursing through your system, you slowly and carefully begin to make your way back upwards.
                            Right as confidence resurges inside of your mind, as you believe that you're going to make it back up to the edge of the well,
                            that you're going to survive this frightening trial with only a near-heart attack to show for it,
                            a loud [b]crack[/b] resonates across the watering hole.
                            The lime-based cement is failing to hold together the well under the added stress of supporting your lightweight frame.
                        [/p]
                        [p]
                            You freeze in place, hoping that hanging still will prevent the circular wall from breaking further, but alas, it is too late.
                            After a few tense moments, the rock-like chunk you tied your rope to [b]breaks apart[/b] the ancient structure.
                            A considerable piece of cobblestone tears away from the rest,
                            and with nothing left to keep your rope-holding rock in place,
                            it gets pulled downwards by your weight, sealing your fate.
                            With nothing left to support you, you fall back-first into the well, your descent followed by several menacing rocks of varying sizes.
                        [/p]
                        [p]
                            You panic, [b]screaming[/b] in terror, thinking this might be the end of you.
                            You wantonly flail your limbs about, scratching and scraping the cobblestone wall surrounding you on all sides with your claws,
                            hoping to [i]latch on[/i] to something, or at least to somewhat slow your fall.
                            Your efforts are in vain.
                            Even if you [b]did[/b] manage to slow yourself down, you'd just get hit by the debris.
                            In a matter of seconds, your terrified shout is cut off,
                            interrupted by a loud series of [b]splashes[/b] as you and the falling rocks both plummet into the cold water at the bottom of the well.
                        [/p]
                        [p]
                            Frigid water rushes into your throat via your open mouth, filling your lungs long before you manage to close your maw.
                            Your descent is quickly halted by the cool liquid, doubly so as your back bumps against the ground at the very base of the well.
                            A large chunk of cobblestone heavily and painfully lands on your stomach, squishing you against the well's muddy base, pinning you in place.
                        [/p]
                        [p]
                            [c]
                                <a href="scenes/HamletDay2/HamletWell/img/drown-debris-${dick ? "m" : "f"}-full.png" target="_blank">
                                    <img class="sfw wideimage" src="scenes/HamletDay2/HamletWell/img/drown-debris-${dick ? "m" : "f"}.png" title="Illustration by ByondRAGE, colored by Nyumii">
                                </a>
                            [/c]
                        [/p]
                        [p]
                            After falling, you find yourself [b]drowning[/b].
                            Panicking, you put every ounce of effort into pushing the heavy rock off of you, to regain your freedom.
                            Your consciousness is rapidly fading due to lack of air.
                            The thing just won't budge!
                            As you can feel life itself starting to slip away from you, you finally manage to dislodge the stone from your abdomen,
                            shoving it to the side a tiny little bit, enough for you to slip out from underneath it.
                            You swim upright.
                            Your feet touch the muddy ground below.
                            In a last-ditch attempt at survival, with your very last shred of power, you kick off from the submerged dirt,
                            launching you towards the surface of the water.
                        [/p]
                        [p]
                            You emerge from the ice-cold liquid, and immediately begin coughing up the watery contents of your respiratory system.
                            Your barely active brain [b]begs[/b] for air, but you can't breathe, not until you've emptied your [b]burning[/b] lungs.
                            After agonizingly [b]vomiting[/b] water from your trachea, you can finally take a much-needed gasp of oxygen,
                            the blackness that had begun to envelop the edges of your vision slightly clearing.
                        [/p]
                        [p]
                            It's not enough.
                            You need [b]more[/b].
                            You need to [b]breathe[/b], lest this damned well become your watery grave still.
                            You hack up more water, taking deep breaths in between each coughing fit.
                            Slowly, but steadily, you recover from the harrowing ordeal you just went through,
                            your breathing stabilizing as liquid drains from your lungs.
                        [/p]
                        [p]
                            It is only after a couple of minutes of recovering, both mentally and physically, that you can breathe normally once more.
                            The damp, stale air at the bottom of the well is of poor quality, but it sure as hell beats drowning.
                            Your gently kicking legs and your arms slowly rocking along the surface of the water keep your light frame afloat.
                            The water isn't [i]that[/i] deep.
                            You figure a tall human could stand in here, but you can't.
                        [/p]
                        [p]
                            The rock you tied your ${global.kobold.inventory.createItemWithTooltip(new Rope())} to came loose.
                            It slid against the well's edge, and after a little while, it ended up breaking the old construct.
                            An unfortunate series of events that nearly cost you your life.
                            You didn't die, though.
                            Not yet, anyway.
                        [/p]
                        [p]
                            Your ${global.kobold.inventory.createItemWithTooltip(new Rope())} is floating on the water's surface next to you.
                            It must have gotten untangled from the chunk you tied it to somewhere during or after the fall.
                            You pocket it once more.
                            While there's a bad memory attached to it now, it might still be useful later on.
                            You let out a sigh of relief, quickly followed by an annoyed groan as you tilt your head upwards,
                            and realize that you're several meters underground with no easy way up.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Dive down</button>`;

        var tooltip = global.parser.parse(`You're not worried about getting out just yet. Dive down to see what's at the bottom of the well.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Climb out</button>`;

        var tooltip = global.parser.parse(`Scale the walls to get out of this claustrophobic hole.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Call for help</button>`;

        var tooltip = global.parser.parse(`You don't think you can climb up by yourself. Maybe someone's around to help you out.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 230px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        ctrl.bgm.loop();
        global.ui.imageBackground.hide();
        global.ui.applyTheme("hamlet_well");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        if (changeController) {
            part += changeController.change();
        }
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}
